## gitlab-workhorse 8.37.0+debian

=== debian/changelog ===
gitlab-workhorse (8.37.0+debian-1) unstable; urgency=medium

  * Update minimum version of golang-github-stretchr-testify-dev to 1.4
  * New upstream version 8.37.0+debian

 -- Pirate Praveen <praveen@debian.org>  Sat, 25 Jul 2020 22:49:30 +0530

gitlab-workhorse (8.36.0+debian-1) unstable; urgency=medium

  * New upstream version 8.36.0+debian
  * Disable more tests via debian/clean (dependencies not packaged)
  * Add golang-github-aws-aws-sdk-go-dev to Build-Depends

 -- Pirate Praveen <praveen@debian.org>  Mon, 22 Jun 2020 18:01:16 +0530

gitlab-workhorse (8.32.0+debian-2) unstable; urgency=medium

  [ Pirate Praveen ]
  * Drop github.com/FZambia/sentinel from vendor and use packaged version
  * Bump minimum version to golang-any to 1.14

  [ Lucas Kanashiro ]
  * Do not b-d on golang-prometheus-client-dev

 -- Pirate Praveen <praveen@debian.org>  Tue, 02 Jun 2020 19:42:30 +0530

gitlab-workhorse (8.32.0+debian-1) unstable; urgency=medium

  * New upstream version 8.32.0+debian
  * Add golang-github-alecthomas-chroma-dev to Build-Depends

 -- Pirate Praveen <praveen@debian.org>  Sat, 23 May 2020 15:22:39 +0530

gitlab-workhorse (8.30.1+debian-1) unstable; urgency=medium

  * Use golang-github-client9-reopen-dev as build dependency
    and drop from vendor
  * Drop Files-Excluded from copyright (vendor is manually created now)
  * New upstream version 8.30.1+debian

 -- Pirate Praveen <praveen@debian.org>  Wed, 22 Apr 2020 21:45:29 +0530

gitlab-workhorse (8.30+debian-1) unstable; urgency=medium

  * Update build dependencies for buster-backports build
  * New upstream version 8.30+debian
  * Exclude cable_test.go from tests (needs definitions from other excluded
    tests)

 -- Pirate Praveen <praveen@debian.org>  Mon, 06 Apr 2020 00:35:37 +0530

=== debian/control ===
Source: gitlab-workhorse
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Pirate Praveen <praveen@debian.org>,
           Utkarsh Gupta <guptautkarsh2102@gmail.com>
Section: httpd
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               golang-any (>= 2:1.14~),
               golang-github-alecthomas-chroma-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-beorn7-perks-dev,
               golang-github-client9-reopen-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
               golang-github-fzambia-sentinel-dev,
               golang-github-garyburd-redigo-dev,
#              golang-github-getsentry-raven-go-dev,
               golang-github-gomodule-redigo-dev,
               golang-github-jfbus-httprs-dev,
               golang-github-jpillora-backoff-dev,
               golang-github-mitchellh-copystructure-dev,
               golang-github-mitchellh-reflectwalk-dev,
               golang-github-pmezard-go-difflib-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-common-dev,
               golang-github-sebest-xff-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-stretchr-testify-dev (>= 1.4~),
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
               golang-google-genproto-dev,
               golang-goprotobuf-dev (>= 1.3~),
               golang-procfs-dev,
               golang-protobuf-extensions-dev,
               golang-toml-dev,
               golang-websocket-dev,
               golang-google-grpc-dev (>= 1.22~),
## tests:
    libimage-exiftool-perl,
#git,
#curl,
#unzip
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse
Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-workhorse
Rules-Requires-Root: no

Package: gitlab-workhorse
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: unloads Git HTTP traffic from the GitLab Rails app (Unicorn)
 gitlab-workhorse was designed to unload Git HTTP traffic from the GitLab Rails
 app (Unicorn) to a separate daemon. It also serves 'git archive' downloads for
 GitLab. All authentication and authorization logic is still handled by the
 GitLab Rails app.
 .
 Architecture: Git client -> NGINX -> gitlab-workhorse (makes auth request to
 GitLab Rails app) -> git-upload-pack

## gitlab-workhorse 8.39.0+debian

=== Makefile ===
PREFIX=/usr/local
PKG := gitlab.com/gitlab-org/gitlab-workhorse
BUILD_DIR ?= $(CURDIR)
TARGET_DIR ?= $(BUILD_DIR)/_build
TARGET_SETUP := $(TARGET_DIR)/.ok
BIN_BUILD_DIR := $(TARGET_DIR)/bin
COVERAGE_DIR := $(TARGET_DIR)/cover
VERSION_STRING := $(shell git describe)
ifeq ($(strip $(VERSION_STRING)),)
VERSION_STRING := v$(shell cat VERSION)
endif
BUILD_TIME := $(shell date -u +%Y%m%d.%H%M%S)
GOBUILD := go build -ldflags "-X main.Version=$(VERSION_STRING) -X main.BuildTime=$(BUILD_TIME)"
EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
INSTALL := install
BUILD_TAGS := tracer_static tracer_static_jaeger continuous_profiler_stackdriver

MINIMUM_SUPPORTED_GO_VERSION := 1.11

export GOBIN := $(TARGET_DIR)/bin
export PATH := $(GOBIN):$(PATH)
export GOPROXY ?= https://proxy.golang.org
export GO111MODULE=on

LOCAL_GO_FILES = $(shell find . -type f -name '*.go' | grep -v -e /_ -e /testdata/)

define message
	@echo "### $(1)"
endef


.NOTPARALLEL:

.PHONY:	all
all:	clean-build $(EXE_ALL)

$(TARGET_SETUP):
	$(call message,"Setting up target directory")
	rm -rf "$(TARGET_DIR)"
	mkdir -p "$(TARGET_DIR)"
	touch "$(TARGET_SETUP)"

gitlab-zip-cat:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-cat/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-zip-metadata:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-workhorse:	$(TARGET_SETUP) $(shell find . -name '*.go' | grep -v '^\./_')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)

.PHONY:	install
install:	gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	$(call message,$@)
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	cd $(BUILD_DIR) && $(INSTALL) gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata $(DESTDIR)$(PREFIX)/bin/

.PHONY:	test
test: $(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test -tags "$(BUILD_TAGS)" ./...
	@echo SUCCESS

.PHONY:	coverage
coverage:	$(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test -tags "$(BUILD_TAGS)" -cover -coverprofile=test.coverage ./...
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

.PHONY:	clean
clean:	clean-workhorse clean-build
	$(call message,$@)
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	$(call message,$@)
	rm -f $(EXE_ALL)

.PHONY: check-version
check-version:
	@test -n "$(VERSION)" || (echo "VERSION not set." ; exit 1)

.PHONY:	tag
tag: check-version
	$(call message,$@)
	sh _support/tag.sh "$(VERSION)"

.PHONY:	signed_tag
signed_tag: check-version
	$(call message,$@)
	TAG_OPTS=-s sh _support/tag.sh "$(VERSION)"

.PHONY:	clean-build
clean-build:
	$(call message,$@)
	rm -rf $(TARGET_DIR)

.PHONY:	prepare-tests
prepare-tests:	testdata/data/group/test.git $(EXE_ALL)
prepare-tests:	testdata/scratch

testdata/data/group/test.git:
	$(call message,$@)
	git clone --quiet --bare https://gitlab.com/gitlab-org/gitlab-test.git $@

testdata/scratch:
	mkdir -p testdata/scratch

.PHONY: verify
verify: lint vet detect-context check-formatting staticcheck

.PHONY: lint
lint: $(TARGET_SETUP)
	$(call message,Verify: $@)
	go install golang.org/x/lint/golint
	@_support/lint.sh ./...

.PHONY: vet
vet: $(TARGET_SETUP) 
	$(call message,Verify: $@)
	@go vet ./...

.PHONY: detect-context
detect-context: $(TARGET_SETUP)
	$(call message,Verify: $@)
	_support/detect-context.sh

.PHONY: check-formatting
check-formatting: $(TARGET_SETUP) install-goimports
	$(call message,Verify: $@)
	@_support/validate-formatting.sh $(LOCAL_GO_FILES)

# Megacheck will tailor some responses given a minimum Go version, so pass that through the CLI
# Additionally, megacheck will not return failure exit codes unless explicitly told to via the
# `-simple.exit-non-zero` `-unused.exit-non-zero` and `-staticcheck.exit-non-zero` flags
.PHONY: staticcheck
staticcheck: $(TARGET_SETUP)
	$(call message,Verify: $@)
	go install honnef.co/go/tools/cmd/staticcheck
	@ $(GOBIN)/staticcheck -go $(MINIMUM_SUPPORTED_GO_VERSION) ./...

# In addition to fixing imports, goimports also formats your code in the same style as gofmt
# so it can be used as a replacement.
.PHONY: fmt
fmt: $(TARGET_SETUP) install-goimports
	$(call message,$@)
	@goimports -w -local $(PKG) -l $(LOCAL_GO_FILES)

.PHONY:	goimports
install-goimports:	$(TARGET_SETUP)
	$(call message,$@)
	go install golang.org/x/tools/cmd/goimports

## gitlab-workhorse 8.54.2%2Bdebian

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 endif
 BUILD_TIME := $(shell date -u +%Y%m%d.%H%M%S)
 GOBUILD := go build -ldflags "-X main.Version=$(VERSION_STRING) -X main.BuildTime=$(BUILD_TIME)"
-EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
+EXE_ALL := gitlab-resize-image gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
 INSTALL := install
 BUILD_TAGS := tracer_static tracer_static_jaeger continuous_profiler_stackdriver
 
@@ -22,7 +22,7 @@
 export GOPROXY ?= https://proxy.golang.org
 export GO111MODULE=on
 
-LOCAL_GO_FILES = $(shell find . -type f -name '*.go' | grep -v -e /_ -e /testdata/)
+LOCAL_GO_FILES = $(shell find . -type f -name '*.go' | grep -v -e /_ -e /testdata/ -e '^\./\.')
 
 define message
 	@echo "### $(1)"
@@ -40,6 +40,10 @@
 	mkdir -p "$(TARGET_DIR)"
 	touch "$(TARGET_SETUP)"
 
+gitlab-resize-image: $(TARGET_SETUP) $(shell find cmd/gitlab-resize-image/ -name '*.go')
+	$(call message,Building $@)
+	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
+
 gitlab-zip-cat:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-cat/ -name '*.go')
 	$(call message,Building $@)
 	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
@@ -53,10 +57,10 @@
 	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)
 
 .PHONY:	install
-install:	gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
+install:	$(EXE_ALL)
 	$(call message,$@)
 	mkdir -p $(DESTDIR)$(PREFIX)/bin/
-	cd $(BUILD_DIR) && $(INSTALL) gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata $(DESTDIR)$(PREFIX)/bin/
+	cd $(BUILD_DIR) && $(INSTALL) $(EXE_ALL) $(DESTDIR)$(PREFIX)/bin/
 
 .PHONY:	test
 test: $(TARGET_SETUP) prepare-tests
@@ -112,7 +116,7 @@
 	mkdir -p testdata/scratch
 
 .PHONY: verify
-verify: lint vet detect-context check-formatting staticcheck
+verify: lint vet detect-context detect-assert check-formatting staticcheck deps-check
 
 .PHONY: lint
 lint: $(TARGET_SETUP)
@@ -129,6 +133,11 @@
 detect-context: $(TARGET_SETUP)
 	$(call message,Verify: $@)
 	_support/detect-context.sh
+
+.PHONY: detect-assert
+detect-assert:
+	$(call message,Verify: $@)
+	_support/detect-assert.sh
 
 .PHONY: check-formatting
 check-formatting: $(TARGET_SETUP) install-goimports
@@ -155,3 +164,14 @@
 install-goimports:	$(TARGET_SETUP)
 	$(call message,$@)
 	go install golang.org/x/tools/cmd/goimports
+
+.PHONY: deps-check
+deps-check:
+	go mod tidy
+	@if git diff --quiet --exit-code -- go.mod go.sum; then \
+		echo "go.mod and go.sum are ok"; \
+	else \
+		echo ""; \
+		echo "go.mod and go.sum are modified, please commit them";\
+		exit 1; \
+	fi;

## gitlab-workhorse 8.54.2+debian

=== debian/changelog ===
gitlab-workhorse (8.54.2+debian-1) unstable; urgency=medium

  * Team Upload.
  [ Pirate Praveen ]
  * Update minimum version of golang-github-azure-azure-storage-blob-go-dev
  * Add golang-github-disintegration-imaging-dev to build depends
  * New upstream version 8.54.2+debian

  [ Nilesh Patra ]
  * d/p/search-binaries-in-path.patch: Look for gitlab-workhorse
    binaries also in all paths in PATH env variable

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 26 Jan 2021 16:24:53 +0000

gitlab-workhorse (8.46.0+debian-1) unstable; urgency=medium

  [ Pirate Praveen ]
  * Add explicit build dependency on golang-github-jtolds-gls-dev
  * New upstream version 8.46.0+debian

 -- Sruthi Chandran <srud@debian.org>  Fri, 27 Nov 2020 01:51:50 +0530

gitlab-workhorse (8.39.0+debian-1) unstable; urgency=medium

  * New upstream version 8.39.0+debian
  * Add a note about embedding golang-github-alecthomas-chroma
    (Closes: #971155)

 -- Pirate Praveen <praveen@debian.org>  Wed, 28 Oct 2020 20:08:56 +0530

=== debian/control ===
--- 
+++ 
@@ -9,15 +9,19 @@
                golang-any (>= 2:1.14~),
                golang-github-alecthomas-chroma-dev,
                golang-github-aws-aws-sdk-go-dev,
+               golang-github-azure-azure-storage-blob-go-dev (>= 0.10~),
                golang-github-beorn7-perks-dev,
                golang-github-client9-reopen-dev,
                golang-github-davecgh-go-spew-dev,
                golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
+               golang-github-disintegration-imaging-dev,
                golang-github-fzambia-sentinel-dev,
                golang-github-garyburd-redigo-dev,
 #              golang-github-getsentry-raven-go-dev,
+               golang-github-google-uuid-dev,
                golang-github-gomodule-redigo-dev,
                golang-github-jfbus-httprs-dev,
+                 golang-github-jtolds-gls-dev (>= 4.20~),
                golang-github-jpillora-backoff-dev,
                golang-github-mitchellh-copystructure-dev,
                golang-github-mitchellh-reflectwalk-dev,
@@ -28,11 +32,13 @@
                golang-github-sebest-xff-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-stretchr-testify-dev (>= 1.4~),
+               golang-gocloud-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
                golang-google-genproto-dev,
                golang-goprotobuf-dev (>= 1.3~),
+               golang-honnef-go-tools-dev,
                golang-procfs-dev,
                golang-protobuf-extensions-dev,
                golang-toml-dev,

=== debian/rules ===
#!/usr/bin/make -f

#export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA = testdata
export DH_GOLANG_EXCLUDES := internal/redis internal/artifacts

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_test:
	PATH="$(CURDIR)/_build/bin:$$PATH" dh_auto_test
